

/*
Author        : ZULQANI FAUZI
Created Date  : 05 / 07 / 2018
Updated Date  : 16 / 07 / 2018
*/

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ModalController, ToastController} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {Common} from "../../providers/common";
import {CommonProduct} from "../../providers/common-product";
import {CustomerPage} from '../customer/customer'; // untuk menampilkan pencarian pelanggan
import {PromoPage} from '../promo/promo';
import {PosMetodePembayaran} from '../pos-metode-pembayaran/pos-metode-pembayaran'; // untuk menampilkan pencarian pelanggan
//import {BluetoothSerial} from '@ionic-native/bluetooth-serial';
import {PrintProvider} from '../../providers/print/print';
import {PrinterListModalPage} from '../printer-list-modal/printer-list-modal';
@IonicPage()
@Component({
    selector: 'page-pos-penjualan',
    templateUrl: 'pos-penjualan.html'
})

export class PosPenjualan {
    public userDetails: any;
    public resposeData: any;
    public recartData: any;
    public cartData: any;
    public dataProduct: any;
    public dataCategory: any;
    public categoryData: any;
    public noRecords: boolean;
    public dataPrint: any;
    public adaPromo: boolean = true;
    selectedPrinter: any = [];

    public total_item: 0;
    public total: 0;
    userPostData = {
        nama_depan: "",
        nama_belakang: "",
        id_member: ""
    };

    userCart = {
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        quantity: "",
        price: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        jumlah_diskon: 0,
        promo: "",
        id_promo: "",
        pajak: true,
        ppn: 0,
        type_cart:"",
    }

    stepper2: number;
    private valQty = 0;

    constructor(public navCtrl: NavController,
        public navParams: NavParams,
        public alertCtrl: AlertController,
        public authService: AuthService,
        public common: Common,
        public commonproduct : CommonProduct,
        private toastCtrl: ToastController,
//        private bluetoothSeral: BluetoothSerial,
        private modalCtrl: ModalController,
        private printProvider: PrintProvider) {
        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userCart.username = this.userDetails.username;
        this.userCart.token = this.userDetails.token;
        this.userCart.jumlah_diskon = 0;
        this.userCart.type_cart = "1";
        this.getCart();
        this.getProduk();
    }

    ionViewDidLoad() {}

    quantity($value) {
        this.valQty = $value;
    }

    PencarianPelanggan() {
        this.navCtrl.push(CustomerPage, {'cart_id': this.userCart.cart_id, 'username': this.userCart.username});
    }

    PencarianPromo() {
        this.navCtrl.push(PromoPage, {'cart_id': this.userCart.cart_id, 'username': this.userCart.username});
    }

    insertCart($data) {
        this.userCart.price = $data.UnitPrice;
        this.userCart.quantity = "1";
        this.userCart.type_cart = "1";
        this.userCart.ItemID = $data.ItemID;
        if (this.userCart.id_pelanggan === '') {
            this.userCart.id_pelanggan = '0001';
            this.userCart.nama_pelanggan = 'UMUM';
        }
        if (this.userCart.ItemID) {
            this.authService.postData(this.userCart, "insertCart").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                        this.cartData = this.resposeData.cartData;
                        this.total_item = this.cartData.length;
                        setTimeout(() => {
                        }, 150);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.presentToast("Gagal mengambil produk.");
        }
    }

    getCart() {
        this.userCart.type_cart = "1";
        this.authService.postData(this.userCart, "getCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.userCart.cart_id = this.cartData[0].cart_id;
                    this.userCart.id_pelanggan = this.cartData[0].id_pelanggan;
                    this.userCart.nama_pelanggan = this.cartData[0].nama_depan + " " + this.cartData[0].nama_belakang;
                    this.userCart.promo = this.cartData[0].promo;
                    this.total_item = this.cartData.length;
                    if (this.userCart.promo === null) {
                        this.adaPromo = false;
                    } else {
                        this.adaPromo = true;
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    updateCart($value) {
        this.userCart.cart_item_id = $value.cart_item_id;
        this.userCart.quantity = $value.quantity;
        this.userCart.price = $value.price;
        this.userCart.ItemID = $value.product_id;
        this.authService.postData(this.userCart, "updateCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.total_item = this.cartData.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    getProduk() {
        this.authService.postData(this.userPostData, "product").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.productData) {
                    this.dataProduct = this.resposeData.productData;
                    const dataLength = this.resposeData.productData.length;
                    if (dataLength == 0) {
                        this.noRecords = true;
                    }
                } else {
                    this.noRecords = true;
                }
            },
            err => {
                this.noRecords = true;
            }
        );
    }

    deleteCart($value) {
        this.userCart.cart_item_id = $value.cart_item_id;
        this.userCart.quantity = $value.quantity;
        this.userCart.price = $value.price;
        this.userCart.ItemID = $value.product_id;
        this.authService.postData(this.userCart, "deleteCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.total_item = this.cartData.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    deletePromo($value) {
        this.userCart.cart_id = $value.cart_id;
        this.userCart.id_promo = '';
        this.authService.postData(this.userCart, "updatePromo").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.total_item = this.cartData.length;
                    this.userCart.promo = "";
                    this.adaPromo = false;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertPenjualan() {
        this.authService.postData(this.userCart, "getCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.userCart.cart_id = this.cartData[0].cart_id;
                    this.userCart.id_pelanggan = this.cartData[0].id_pelanggan;
                    this.userCart.nama_pelanggan = this.cartData[0].nama_depan + " " + this.cartData[0].nama_belakang;
                    this.userCart.promo = this.cartData[0].promo;
                    this.total_item = this.cartData.length;
                    if (this.userCart.promo === null) {
                        this.adaPromo = false;
                    } else {
                        this.adaPromo = true;
                    }
                    if (this.userCart.cart_id) {
                        if (this.userCart.pajak === true) {
                            this.userCart.ppn = 10;
                        } else {
                            this.userCart.ppn = 0;
                        }
                        this.navCtrl.push(PosMetodePembayaran, {
                            'cart_id': this.userCart.cart_id,
                            'username': this.userCart.username,
                            'diskon': this.userCart.diskon,
                            'jumlah_diskon': this.userCart.jumlah_diskon,
                            'promo': this.userCart.promo,
                            'ppn': this.userCart.ppn,
                            'catatan': this.userCart.catatan
                        });
                    } else {
                        this.presentToast("Data penjualan masih kosong.");
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }


    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }

    //printer
    listBTDevice() {
        this.printProvider.searchBt().then(datalist => {

            //1. Open printer select modal
            let abc = this.modalCtrl.create(PrinterListModalPage, {data: datalist});

            //2. Printer selected, save into this.selectedPrinter
            abc.onDidDismiss(data => {
                this.selectedPrinter = data;

                let xyz = this.alertCtrl.create({
                    title: data.name + " selected",
                    buttons: ['Dismiss']
                });
                xyz.present();

            });

            //0. Present Modal
            abc.present();

        }, err => {
            console.log("ERROR", err);
            let mno = this.alertCtrl.create({
                title: "ERROR " + err,
                buttons: ['Dismiss']
            });
            mno.present();
        })

    }

    testConnectPrinter() {
        var id = this.selectedPrinter.id;
        if (id == null || id == "" || id == undefined) {
            //nothing happens, you can put an alert here saying no printer selected
        }
        else {
            this.printProvider.connectBT(id).subscribe(data => {
                console.log("CONNECT SUCCESSFUL", data);

                let mno = this.alertCtrl.create({
                    title: "Connect successful",
                    buttons: ['Dismiss']
                });
                mno.present();

            }, err => {
                console.log("Not able to connect", err);
                let mno = this.alertCtrl.create({
                    title: "ERROR " + err,
                    buttons: ['Dismiss']
                });
                mno.present();
            });
        }
    }

    testPrinter() {
        var id = this.selectedPrinter.id;
        if (id == null || id == "" || id == undefined) {
            //nothing happens, you can put an alert here saying no printer selected
        }
        else {
            var receipt = '';
            receipt += '\x1b\x40'; // Clear data in buffer and reset modes
            receipt += '\x1b\x61\x01'; 
            receipt += '\x1b\x21\x20'; 
            receipt += 'Kara Island';
            receipt += '\n\n';
            receipt += '\x1b\x21\x00'; 
            receipt += 'Gandaria City, Lantai 2';
            receipt += '\n';
            receipt += 'Jl. Sultan Iskandar Muda \n Gandaria, Jakarta';
            receipt += '\n';
            receipt += '0812 19999 6767';
            receipt += '\n\n';


//            for (let i = 0; i < this.userCart.length; i++) {
//                receipt += '\x1b\x61\x00'; // Left justification
//                receipt += this.userCart[i].Item;
//                receipt += '\x1b\x61\x02'; // Right justification
//                receipt += this.userCart[i].qty;
//                receipt += this.userCart[i].price;
//                receipt += '\n';
//            }
            this.printProvider.testPrint(id, receipt);
        }
    